Index: kernel/generic/src/synch/waitq.c
===================================================================
--- kernel/generic/src/synch/waitq.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/synch/waitq.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2001-2004 Jakub Jermar
+ * Copyright (c) 2022 Jiří Zárevúcky
  * All rights reserved.
  *
@@ -48,4 +49,5 @@
 #include <synch/waitq.h>
 #include <synch/spinlock.h>
+#include <preemption.h>
 #include <proc/thread.h>
 #include <proc/scheduler.h>
@@ -57,8 +59,5 @@
 #include <adt/list.h>
 #include <arch/cycle.h>
-#include <mem.h>
-
-static void waitq_sleep_timed_out(void *);
-static void waitq_complete_wakeup(waitq_t *);
+#include <memw.h>
 
 /** Initialize wait queue
@@ -76,117 +75,12 @@
 }
 
-/** Handle timeout during waitq_sleep_timeout() call
- *
- * This routine is called when waitq_sleep_timeout() times out.
- * Interrupts are disabled.
- *
- * It is supposed to try to remove 'its' thread from the wait queue;
- * it can eventually fail to achieve this goal when these two events
- * overlap. In that case it behaves just as though there was no
- * timeout at all.
- *
- * @param data Pointer to the thread that called waitq_sleep_timeout().
- *
- */
-void waitq_sleep_timed_out(void *data)
-{
-	thread_t *thread = (thread_t *) data;
-	bool do_wakeup = false;
-	DEADLOCK_PROBE_INIT(p_wqlock);
-
-	irq_spinlock_lock(&threads_lock, false);
-	if (!thread_exists(thread))
-		goto out;
-
-grab_locks:
-	irq_spinlock_lock(&thread->lock, false);
-
-	waitq_t *wq;
-	if ((wq = thread->sleep_queue)) {  /* Assignment */
-		if (!irq_spinlock_trylock(&wq->lock)) {
-			irq_spinlock_unlock(&thread->lock, false);
-			DEADLOCK_PROBE(p_wqlock, DEADLOCK_THRESHOLD);
-			/* Avoid deadlock */
-			goto grab_locks;
-		}
-
-		list_remove(&thread->wq_link);
-		thread->saved_context = thread->sleep_timeout_context;
-		do_wakeup = true;
-		if (thread->sleep_composable)
-			wq->ignore_wakeups++;
-		thread->sleep_queue = NULL;
-		irq_spinlock_unlock(&wq->lock, false);
-	}
-
-	thread->timeout_pending = false;
-	irq_spinlock_unlock(&thread->lock, false);
-
-	if (do_wakeup)
-		thread_ready(thread);
-
-out:
-	irq_spinlock_unlock(&threads_lock, false);
-}
-
-/** Interrupt sleeping thread.
- *
- * This routine attempts to interrupt a thread from its sleep in
- * a waitqueue. If the thread is not found sleeping, no action
- * is taken.
- *
- * The threads_lock must be already held and interrupts must be
- * disabled upon calling this function.
- *
- * @param thread Thread to be interrupted.
- *
- */
-void waitq_interrupt_sleep(thread_t *thread)
-{
-	bool do_wakeup = false;
-	DEADLOCK_PROBE_INIT(p_wqlock);
-
-	/*
-	 * The thread is quaranteed to exist because
-	 * threads_lock is held.
-	 */
-
-grab_locks:
-	irq_spinlock_lock(&thread->lock, false);
-
-	waitq_t *wq;
-	if ((wq = thread->sleep_queue)) {  /* Assignment */
-		if (!(thread->sleep_interruptible)) {
-			/*
-			 * The sleep cannot be interrupted.
-			 */
-			irq_spinlock_unlock(&thread->lock, false);
-			return;
-		}
-
-		if (!irq_spinlock_trylock(&wq->lock)) {
-			/* Avoid deadlock */
-			irq_spinlock_unlock(&thread->lock, false);
-			DEADLOCK_PROBE(p_wqlock, DEADLOCK_THRESHOLD);
-			goto grab_locks;
-		}
-
-		if ((thread->timeout_pending) &&
-		    (timeout_unregister(&thread->sleep_timeout)))
-			thread->timeout_pending = false;
-
-		list_remove(&thread->wq_link);
-		thread->saved_context = thread->sleep_interruption_context;
-		if (thread->sleep_composable)
-			wq->ignore_wakeups++;
-		do_wakeup = true;
-		thread->sleep_queue = NULL;
-		irq_spinlock_unlock(&wq->lock, false);
-	}
-
-	irq_spinlock_unlock(&thread->lock, false);
-
-	if (do_wakeup)
-		thread_ready(thread);
+/**
+ * Initialize wait queue with an initial number of queued wakeups
+ * (or a wakeup debt if negative).
+ */
+void waitq_initialize_with_count(waitq_t *wq, int count)
+{
+	waitq_initialize(wq);
+	wq->wakeup_balance = count;
 }
 
@@ -194,13 +88,20 @@
 	(((flags) & SYNCH_FLAGS_NON_BLOCKING) && ((usec) == 0))
 
+errno_t waitq_sleep(waitq_t *wq)
+{
+	return _waitq_sleep_timeout(wq, SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE);
+}
+
+errno_t waitq_sleep_timeout(waitq_t *wq, uint32_t usec)
+{
+	return _waitq_sleep_timeout(wq, usec, SYNCH_FLAGS_NON_BLOCKING);
+}
+
 /** Sleep until either wakeup, timeout or interruption occurs
  *
- * This is a sleep implementation which allows itself to time out or to be
- * interrupted from the sleep, restoring a failover context.
- *
  * Sleepers are organised in a FIFO fashion in a structure called wait queue.
  *
- * This function is really basic in that other functions as waitq_sleep()
- * and all the *_timeout() functions use it.
+ * Other functions as waitq_sleep() and all the *_timeout() functions are
+ * implemented using this function.
  *
  * @param wq    Pointer to wait queue.
@@ -208,8 +109,4 @@
  * @param flags Specify mode of the sleep.
  *
- * @param[out] blocked  On return, regardless of the return code,
- *                      `*blocked` is set to `true` iff the thread went to
- *                      sleep.
- *
  * The sleep can be interrupted only if the
  * SYNCH_FLAGS_INTERRUPTIBLE bit is specified in flags.
@@ -225,29 +122,15 @@
  * call will immediately return, reporting either success or failure.
  *
- * @return EAGAIN, meaning that the sleep failed because it was requested
- *                 as SYNCH_FLAGS_NON_BLOCKING, but there was no pending wakeup.
- * @return ETIMEOUT, meaning that the sleep timed out.
- * @return EINTR, meaning that somebody interrupted the sleeping
- *         thread. Check the value of `*blocked` to see if the thread slept,
- *         or if a pending interrupt forced it to return immediately.
+ * @return ETIMEOUT, meaning that the sleep timed out, or a nonblocking call
+ *                   returned unsuccessfully.
+ * @return EINTR, meaning that somebody interrupted the sleeping thread.
  * @return EOK, meaning that none of the above conditions occured, and the
- *              thread was woken up successfuly by `waitq_wakeup()`. Check
- *              the value of `*blocked` to see if the thread slept or if
- *              the wakeup was already pending.
- *
- */
-errno_t waitq_sleep_timeout(waitq_t *wq, uint32_t usec, unsigned int flags, bool *blocked)
+ *              thread was woken up successfuly by `waitq_wake_*()`.
+ *
+ */
+errno_t _waitq_sleep_timeout(waitq_t *wq, uint32_t usec, unsigned int flags)
 {
 	assert((!PREEMPTION_DISABLED) || (PARAM_NON_BLOCKING(flags, usec)));
-
-	ipl_t ipl = waitq_sleep_prepare(wq);
-	bool nblocked;
-	errno_t rc = waitq_sleep_timeout_unsafe(wq, usec, flags, &nblocked);
-	waitq_sleep_finish(wq, nblocked, ipl);
-
-	if (blocked != NULL) {
-		*blocked = nblocked;
-	}
-	return rc;
+	return waitq_sleep_timeout_unsafe(wq, usec, flags, waitq_sleep_prepare(wq));
 }
 
@@ -262,67 +145,16 @@
  *
  */
-ipl_t waitq_sleep_prepare(waitq_t *wq)
-{
-	ipl_t ipl;
-
-restart:
-	ipl = interrupts_disable();
-
-	if (THREAD) {  /* Needed during system initiailzation */
-		/*
-		 * Busy waiting for a delayed timeout.
-		 * This is an important fix for the race condition between
-		 * a delayed timeout and a next call to waitq_sleep_timeout().
-		 * Simply, the thread is not allowed to go to sleep if
-		 * there are timeouts in progress.
-		 *
-		 */
-		irq_spinlock_lock(&THREAD->lock, false);
-
-		if (THREAD->timeout_pending) {
-			irq_spinlock_unlock(&THREAD->lock, false);
-			interrupts_restore(ipl);
-			goto restart;
-		}
-
-		irq_spinlock_unlock(&THREAD->lock, false);
-	}
-
+wait_guard_t waitq_sleep_prepare(waitq_t *wq)
+{
+	ipl_t ipl = interrupts_disable();
 	irq_spinlock_lock(&wq->lock, false);
-	return ipl;
-}
-
-/** Finish waiting in a wait queue.
- *
- * This function restores interrupts to the state that existed prior
- * to the call to waitq_sleep_prepare(). If necessary, the wait queue
- * lock is released.
- *
- * @param wq       Wait queue.
- * @param blocked  Out parameter of waitq_sleep_timeout_unsafe().
- * @param ipl      Interrupt level returned by waitq_sleep_prepare().
- *
- */
-void waitq_sleep_finish(waitq_t *wq, bool blocked, ipl_t ipl)
-{
-	if (blocked) {
-		/*
-		 * Wait for a waitq_wakeup() or waitq_unsleep() to complete
-		 * before returning from waitq_sleep() to the caller. Otherwise
-		 * the caller might expect that the wait queue is no longer used
-		 * and deallocate it (although the wakeup on a another cpu has
-		 * not yet completed and is using the wait queue).
-		 *
-		 * Note that we have to do this for EOK and EINTR, but not
-		 * necessarily for ETIMEOUT where the timeout handler stops
-		 * using the waitq before waking us up. To be on the safe side,
-		 * ensure the waitq is not in use anymore in this case as well.
-		 */
-		waitq_complete_wakeup(wq);
-	} else {
-		irq_spinlock_unlock(&wq->lock, false);
-	}
-
-	interrupts_restore(ipl);
+	return (wait_guard_t) {
+		.ipl = ipl,
+	};
+}
+
+errno_t waitq_sleep_unsafe(waitq_t *wq, wait_guard_t guard)
+{
+	return waitq_sleep_timeout_unsafe(wq, SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE, guard);
 }
 
@@ -330,6 +162,5 @@
  *
  * This function implements logic of sleeping in a wait queue.
- * This call must be preceded by a call to waitq_sleep_prepare()
- * and followed by a call to waitq_sleep_finish().
+ * This call must be preceded by a call to waitq_sleep_prepare().
  *
  * @param wq    See waitq_sleep_timeout().
@@ -342,252 +173,177 @@
  *
  */
-errno_t waitq_sleep_timeout_unsafe(waitq_t *wq, uint32_t usec, unsigned int flags, bool *blocked)
-{
-	*blocked = false;
+errno_t waitq_sleep_timeout_unsafe(waitq_t *wq, uint32_t usec, unsigned int flags, wait_guard_t guard)
+{
+	errno_t rc;
+
+	/*
+	 * If true, and this thread's sleep returns without a wakeup
+	 * (timed out or interrupted), waitq ignores the next wakeup.
+	 * This is necessary for futex to be able to handle those conditions.
+	 */
+	bool sleep_composable = (flags & SYNCH_FLAGS_FUTEX);
+	bool interruptible = (flags & SYNCH_FLAGS_INTERRUPTIBLE);
+
+	if (wq->closed) {
+		rc = EOK;
+		goto exit;
+	}
 
 	/* Checks whether to go to sleep at all */
-	if (wq->missed_wakeups) {
-		wq->missed_wakeups--;
-		return EOK;
-	} else {
-		if (PARAM_NON_BLOCKING(flags, usec)) {
-			/* Return immediately instead of going to sleep */
-			return EAGAIN;
+	if (wq->wakeup_balance > 0) {
+		wq->wakeup_balance--;
+
+		rc = EOK;
+		goto exit;
+	}
+
+	if (PARAM_NON_BLOCKING(flags, usec)) {
+		/* Return immediately instead of going to sleep */
+		rc = ETIMEOUT;
+		goto exit;
+	}
+
+	/* Just for debugging output. */
+	atomic_store_explicit(&THREAD->sleep_queue, wq, memory_order_relaxed);
+
+	/*
+	 * This thread_t field is synchronized exclusively via
+	 * waitq lock of the waitq currently listing it.
+	 */
+	list_append(&THREAD->wq_link, &wq->sleepers);
+
+	/* Needs to be run when interrupts are still disabled. */
+	deadline_t deadline = usec > 0 ?
+	    timeout_deadline_in_usec(usec) : DEADLINE_NEVER;
+
+	while (true) {
+		bool terminating = (thread_wait_start() == THREAD_TERMINATING);
+		if (terminating && interruptible) {
+			rc = EINTR;
+			goto exit;
 		}
-	}
-
-	/*
-	 * Now we are firmly decided to go to sleep.
-	 *
-	 */
-	irq_spinlock_lock(&THREAD->lock, false);
-
-	THREAD->sleep_composable = (flags & SYNCH_FLAGS_FUTEX);
-
-	if (flags & SYNCH_FLAGS_INTERRUPTIBLE) {
+
+		irq_spinlock_unlock(&wq->lock, false);
+
+		bool timed_out = (thread_wait_finish(deadline) == THREAD_WAIT_TIMEOUT);
+
 		/*
-		 * If the thread was already interrupted,
-		 * don't go to sleep at all.
+		 * We always need to re-lock the WQ, since concurrently running
+		 * waitq_wakeup() may still not have exitted.
+		 * If we didn't always do this, we'd risk waitq_wakeup() that woke us
+		 * up still running on another CPU even after this function returns,
+		 * and that would be an issue if the waitq is allocated locally to
+		 * wait for a one-off asynchronous event. We'd need more external
+		 * synchronization in that case, and that would be a pain.
+		 *
+		 * On the plus side, always regaining a lock simplifies cleanup.
 		 */
-		if (THREAD->interrupted) {
-			irq_spinlock_unlock(&THREAD->lock, false);
-			return EINTR;
+		irq_spinlock_lock(&wq->lock, false);
+
+		if (!link_in_use(&THREAD->wq_link)) {
+			/*
+			 * We were woken up by the desired event. Return success,
+			 * regardless of any concurrent timeout or interruption.
+			 */
+			rc = EOK;
+			goto exit;
 		}
 
-		/*
-		 * Set context that will be restored if the sleep
-		 * of this thread is ever interrupted.
-		 */
-		THREAD->sleep_interruptible = true;
-		if (!context_save(&THREAD->sleep_interruption_context)) {
-			/* Short emulation of scheduler() return code. */
-			THREAD->last_cycle = get_cycle();
-			irq_spinlock_unlock(&THREAD->lock, false);
-			return EINTR;
+		if (timed_out) {
+			rc = ETIMEOUT;
+			goto exit;
 		}
-	} else
-		THREAD->sleep_interruptible = false;
-
-	if (usec) {
-		/* We use the timeout variant. */
-		if (!context_save(&THREAD->sleep_timeout_context)) {
-			/* Short emulation of scheduler() return code. */
-			THREAD->last_cycle = get_cycle();
-			irq_spinlock_unlock(&THREAD->lock, false);
-			return ETIMEOUT;
-		}
-
-		THREAD->timeout_pending = true;
-		timeout_register(&THREAD->sleep_timeout, (uint64_t) usec,
-		    waitq_sleep_timed_out, THREAD);
-	}
-
-	list_append(&THREAD->wq_link, &wq->sleepers);
-
-	/*
-	 * Suspend execution.
-	 *
-	 */
-	THREAD->state = Sleeping;
-	THREAD->sleep_queue = wq;
-
-	/*
-	 * Must be before entry to scheduler, because there are multiple
-	 * return vectors.
-	 */
-	*blocked = true;
-
-	irq_spinlock_unlock(&THREAD->lock, false);
-
-	/* wq->lock is released in scheduler_separated_stack() */
-	scheduler();
-
-	return EOK;
-}
-
-/** Wake up first thread sleeping in a wait queue
- *
- * Wake up first thread sleeping in a wait queue. This is the SMP- and IRQ-safe
- * wrapper meant for general use.
- *
- * Besides its 'normal' wakeup operation, it attempts to unregister possible
- * timeout.
- *
- * @param wq   Pointer to wait queue.
- * @param mode Wakeup mode.
- *
- */
-void waitq_wakeup(waitq_t *wq, wakeup_mode_t mode)
+
+		/* Interrupted for some other reason. */
+	}
+
+exit:
+	if (THREAD)
+		list_remove(&THREAD->wq_link);
+
+	if (rc != EOK && sleep_composable)
+		wq->wakeup_balance--;
+
+	if (THREAD)
+		atomic_store_explicit(&THREAD->sleep_queue, NULL, memory_order_relaxed);
+
+	irq_spinlock_unlock(&wq->lock, false);
+	interrupts_restore(guard.ipl);
+	return rc;
+}
+
+static void _wake_one(waitq_t *wq)
+{
+	/* Pop one thread from the queue and wake it up. */
+	thread_t *thread = list_get_instance(list_first(&wq->sleepers), thread_t, wq_link);
+	list_remove(&thread->wq_link);
+	thread_wakeup(thread);
+}
+
+/**
+ * Meant for implementing condvar signal.
+ * Always wakes one thread if there are any sleeping,
+ * has no effect if no threads are waiting for wakeup.
+ */
+void waitq_signal(waitq_t *wq)
 {
 	irq_spinlock_lock(&wq->lock, true);
-	_waitq_wakeup_unsafe(wq, mode);
+
+	if (!list_empty(&wq->sleepers))
+		_wake_one(wq);
+
 	irq_spinlock_unlock(&wq->lock, true);
 }
 
-/** If there is a wakeup in progress actively waits for it to complete.
- *
- * The function returns once the concurrently running waitq_wakeup()
- * exits. It returns immediately if there are no concurrent wakeups
- * at the time.
- *
- * Interrupts must be disabled.
- *
- * Example usage:
- * @code
- * void callback(waitq *wq)
- * {
- *     // Do something and notify wait_for_completion() that we're done.
- *     waitq_wakeup(wq);
- * }
- * void wait_for_completion(void)
- * {
- *     waitq wg;
- *     waitq_initialize(&wq);
- *     // Run callback() in the background, pass it wq.
- *     do_asynchronously(callback, &wq);
- *     // Wait for callback() to complete its work.
- *     waitq_sleep(&wq);
- *     // callback() completed its work, but it may still be accessing
- *     // wq in waitq_wakeup(). Therefore it is not yet safe to return
- *     // from waitq_sleep() or it would clobber up our stack (where wq
- *     // is stored). waitq_sleep() ensures the wait queue is no longer
- *     // in use by invoking waitq_complete_wakeup() internally.
- *
- *     // waitq_sleep() returned, it is safe to free wq.
- * }
- * @endcode
- *
- * @param wq  Pointer to a wait queue.
- */
-static void waitq_complete_wakeup(waitq_t *wq)
-{
-	assert(interrupts_disabled());
-
-	irq_spinlock_lock(&wq->lock, false);
-	irq_spinlock_unlock(&wq->lock, false);
-}
-
-/** Internal SMP- and IRQ-unsafe version of waitq_wakeup()
- *
- * This is the internal SMP- and IRQ-unsafe version of waitq_wakeup(). It
- * assumes wq->lock is already locked and interrupts are already disabled.
- *
- * @param wq   Pointer to wait queue.
- * @param mode If mode is WAKEUP_FIRST, then the longest waiting
- *             thread, if any, is woken up. If mode is WAKEUP_ALL, then
- *             all waiting threads, if any, are woken up. If there are
- *             no waiting threads to be woken up, the missed wakeup is
- *             recorded in the wait queue.
- *
- */
-void _waitq_wakeup_unsafe(waitq_t *wq, wakeup_mode_t mode)
-{
-	size_t count = 0;
-
-	assert(interrupts_disabled());
-	assert(irq_spinlock_locked(&wq->lock));
-
-	if (wq->ignore_wakeups > 0) {
-		if (mode == WAKEUP_FIRST) {
-			wq->ignore_wakeups--;
-			return;
-		}
-		wq->ignore_wakeups = 0;
-	}
-
-loop:
-	if (list_empty(&wq->sleepers)) {
-		wq->missed_wakeups++;
-		if ((count) && (mode == WAKEUP_ALL))
-			wq->missed_wakeups--;
-
-		return;
-	}
-
-	count++;
-	thread_t *thread = list_get_instance(list_first(&wq->sleepers),
-	    thread_t, wq_link);
-
-	/*
-	 * Lock the thread prior to removing it from the wq.
-	 * This is not necessary because of mutual exclusion
-	 * (the link belongs to the wait queue), but because
-	 * of synchronization with waitq_sleep_timed_out()
-	 * and thread_interrupt_sleep().
-	 *
-	 * In order for these two functions to work, the following
-	 * invariant must hold:
-	 *
-	 * thread->sleep_queue != NULL <=> thread sleeps in a wait queue
-	 *
-	 * For an observer who locks the thread, the invariant
-	 * holds only when the lock is held prior to removing
-	 * it from the wait queue.
-	 *
-	 */
-	irq_spinlock_lock(&thread->lock, false);
-	list_remove(&thread->wq_link);
-
-	if ((thread->timeout_pending) &&
-	    (timeout_unregister(&thread->sleep_timeout)))
-		thread->timeout_pending = false;
-
-	thread->sleep_queue = NULL;
-	irq_spinlock_unlock(&thread->lock, false);
-
-	thread_ready(thread);
-
-	if (mode == WAKEUP_ALL)
-		goto loop;
-}
-
-/** Get the missed wakeups count.
- *
- * @param wq	Pointer to wait queue.
- * @return	The wait queue's missed_wakeups count.
- */
-int waitq_count_get(waitq_t *wq)
-{
-	int cnt;
-
+/**
+ * Wakes up one thread sleeping on this waitq.
+ * If there are no threads waiting, saves the wakeup so that the next sleep
+ * returns immediately. If a previous failure in sleep created a wakeup debt
+ * (see SYNCH_FLAGS_FUTEX) this debt is annulled and no thread is woken up.
+ */
+void waitq_wake_one(waitq_t *wq)
+{
 	irq_spinlock_lock(&wq->lock, true);
-	cnt = wq->missed_wakeups;
+
+	if (!wq->closed) {
+		if (wq->wakeup_balance < 0 || list_empty(&wq->sleepers))
+			wq->wakeup_balance++;
+		else
+			_wake_one(wq);
+	}
+
 	irq_spinlock_unlock(&wq->lock, true);
-
-	return cnt;
-}
-
-/** Set the missed wakeups count.
- *
- * @param wq	Pointer to wait queue.
- * @param val	New value of the missed_wakeups count.
- */
-void waitq_count_set(waitq_t *wq, int val)
+}
+
+static void _wake_all(waitq_t *wq)
+{
+	while (!list_empty(&wq->sleepers))
+		_wake_one(wq);
+}
+
+/**
+ * Wakes up all threads currently waiting on this waitq
+ * and makes all future sleeps return instantly.
+ */
+void waitq_close(waitq_t *wq)
 {
 	irq_spinlock_lock(&wq->lock, true);
-	wq->missed_wakeups = val;
+	wq->wakeup_balance = 0;
+	wq->closed = true;
+	_wake_all(wq);
 	irq_spinlock_unlock(&wq->lock, true);
 }
 
+/**
+ * Wakes up all threads currently waiting on this waitq
+ */
+void waitq_wake_all(waitq_t *wq)
+{
+	irq_spinlock_lock(&wq->lock, true);
+	wq->wakeup_balance = 0;
+	_wake_all(wq);
+	irq_spinlock_unlock(&wq->lock, true);
+}
+
 /** @}
  */
Index: kernel/generic/src/syscall/syscall.c
===================================================================
--- kernel/generic/src/syscall/syscall.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/syscall/syscall.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -141,7 +141,7 @@
 {
 	/* Do userpace accounting */
-	irq_spinlock_lock(&THREAD->lock, true);
+	ipl_t ipl = interrupts_disable();
 	thread_update_accounting(true);
-	irq_spinlock_unlock(&THREAD->lock, true);
+	interrupts_restore(ipl);
 
 #ifdef CONFIG_UDEBUG
@@ -191,7 +191,7 @@
 
 	/* Do kernel accounting */
-	irq_spinlock_lock(&THREAD->lock, true);
+	ipl = interrupts_disable();
 	thread_update_accounting(false);
-	irq_spinlock_unlock(&THREAD->lock, true);
+	interrupts_restore(ipl);
 
 	return rc;
Index: kernel/generic/src/sysinfo/stats.c
===================================================================
--- kernel/generic/src/sysinfo/stats.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/sysinfo/stats.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -119,13 +119,10 @@
 	size_t i;
 	for (i = 0; i < config.cpu_count; i++) {
-		irq_spinlock_lock(&cpus[i].lock, true);
-
 		stats_cpus[i].id = cpus[i].id;
 		stats_cpus[i].active = cpus[i].active;
 		stats_cpus[i].frequency_mhz = cpus[i].frequency_mhz;
-		stats_cpus[i].busy_cycles = cpus[i].busy_cycles;
-		stats_cpus[i].idle_cycles = cpus[i].idle_cycles;
-
-		irq_spinlock_unlock(&cpus[i].lock, true);
+
+		stats_cpus[i].busy_cycles = atomic_time_read(&cpus[i].busy_cycles);
+		stats_cpus[i].idle_cycles = atomic_time_read(&cpus[i].idle_cycles);
 	}
 
@@ -224,5 +221,5 @@
 	stats_task->virtmem = get_task_virtmem(task->as);
 	stats_task->resmem = get_task_resmem(task->as);
-	stats_task->threads = atomic_load(&task->refcount);
+	stats_task->threads = atomic_load(&task->lifecount);
 	task_get_accounting(task, &(stats_task->ucycles),
 	    &(stats_task->kcycles));
@@ -302,16 +299,17 @@
 {
 	assert(interrupts_disabled());
-	assert(irq_spinlock_locked(&thread->lock));
 
 	stats_thread->thread_id = thread->tid;
 	stats_thread->task_id = thread->task->taskid;
-	stats_thread->state = thread->state;
-	stats_thread->priority = thread->priority;
-	stats_thread->ucycles = thread->ucycles;
-	stats_thread->kcycles = thread->kcycles;
-
-	if (thread->cpu != NULL) {
+	stats_thread->state = atomic_get_unordered(&thread->state);
+	stats_thread->priority = atomic_get_unordered(&thread->priority);
+	stats_thread->ucycles = atomic_time_read(&thread->ucycles);
+	stats_thread->kcycles = atomic_time_read(&thread->kcycles);
+
+	cpu_t *cpu = atomic_get_unordered(&thread->cpu);
+
+	if (cpu != NULL) {
 		stats_thread->on_cpu = true;
-		stats_thread->cpu = thread->cpu->id;
+		stats_thread->cpu = cpu->id;
 	} else
 		stats_thread->on_cpu = false;
@@ -332,5 +330,5 @@
     bool dry_run, void *data)
 {
-	/* Messing with threads structures, avoid deadlock */
+	/* Messing with threads structures */
 	irq_spinlock_lock(&threads_lock, true);
 
@@ -364,12 +362,7 @@
 	thread_t *thread = thread_first();
 	while (thread != NULL) {
-		/* Interrupts are already disabled */
-		irq_spinlock_lock(&thread->lock, false);
-
 		/* Record the statistics and increment the index */
 		produce_stats_thread(thread, &stats_threads[i]);
 		i++;
-
-		irq_spinlock_unlock(&thread->lock, false);
 
 		thread = thread_next(thread);
@@ -518,6 +511,7 @@
 {
 	/* Initially no return value */
-	sysinfo_return_t ret;
-	ret.tag = SYSINFO_VAL_UNDEFINED;
+	sysinfo_return_t ret = {
+		.tag = SYSINFO_VAL_UNDEFINED,
+	};
 
 	/* Parse the task ID */
@@ -526,13 +520,7 @@
 		return ret;
 
-	/* Messing with task structures, avoid deadlock */
-	irq_spinlock_lock(&tasks_lock, true);
-
 	task_t *task = task_find_by_id(task_id);
-	if (task == NULL) {
-		/* No task with this ID */
-		irq_spinlock_unlock(&tasks_lock, true);
+	if (!task)
 		return ret;
-	}
 
 	if (dry_run) {
@@ -540,28 +528,21 @@
 		ret.data.data = NULL;
 		ret.data.size = sizeof(stats_task_t);
-
-		irq_spinlock_unlock(&tasks_lock, true);
 	} else {
 		/* Allocate stats_task_t structure */
-		stats_task_t *stats_task =
-		    (stats_task_t *) malloc(sizeof(stats_task_t));
-		if (stats_task == NULL) {
-			irq_spinlock_unlock(&tasks_lock, true);
-			return ret;
+		stats_task_t *stats_task = malloc(sizeof(stats_task_t));
+
+		if (stats_task != NULL) {
+			/* Correct return value */
+			ret.tag = SYSINFO_VAL_FUNCTION_DATA;
+			ret.data.data = stats_task;
+			ret.data.size = sizeof(stats_task_t);
+
+			irq_spinlock_lock(&task->lock, true);
+			produce_stats_task(task, stats_task);
+			irq_spinlock_unlock(&task->lock, true);
 		}
-
-		/* Correct return value */
-		ret.tag = SYSINFO_VAL_FUNCTION_DATA;
-		ret.data.data = (void *) stats_task;
-		ret.data.size = sizeof(stats_task_t);
-
-		/* Hand-over-hand locking */
-		irq_spinlock_exchange(&tasks_lock, &task->lock);
-
-		produce_stats_task(task, stats_task);
-
-		irq_spinlock_unlock(&task->lock, true);
-	}
-
+	}
+
+	task_release(task);
 	return ret;
 }
@@ -597,5 +578,5 @@
 		return ret;
 
-	/* Messing with threads structures, avoid deadlock */
+	/* Messing with threads structures */
 	irq_spinlock_lock(&threads_lock, true);
 
@@ -627,10 +608,7 @@
 		ret.data.size = sizeof(stats_thread_t);
 
-		/* Hand-over-hand locking */
-		irq_spinlock_exchange(&threads_lock, &thread->lock);
-
 		produce_stats_thread(thread, stats_thread);
 
-		irq_spinlock_unlock(&thread->lock, true);
+		irq_spinlock_unlock(&threads_lock, true);
 	}
 
@@ -847,6 +825,4 @@
 void kload(void *arg)
 {
-	thread_detach(THREAD);
-
 	while (true) {
 		size_t ready = atomic_load(&nrdy);
Index: kernel/generic/src/time/clock.c
===================================================================
--- kernel/generic/src/time/clock.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/time/clock.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2001-2004 Jakub Jermar
+ * Copyright (c) 2022 Jiří Zárevúcky
  * All rights reserved.
  *
@@ -58,4 +59,5 @@
 #include <ddi/ddi.h>
 #include <arch/cycle.h>
+#include <preemption.h>
 
 /* Pointer to variable with uptime */
@@ -64,11 +66,4 @@
 /** Physical memory area of the real time clock */
 static parea_t clock_parea;
-
-/** Fragment of second
- *
- * For updating  seconds correctly.
- *
- */
-static sysarg_t secfrag = 0;
 
 /** Initialize realtime clock counter
@@ -109,20 +104,18 @@
  *
  * Update it only on first processor
- * TODO: Do we really need so many write barriers?
- *
- */
-static void clock_update_counters(void)
+ */
+static void clock_update_counters(uint64_t current_tick)
 {
 	if (CPU->id == 0) {
-		secfrag += 1000000 / HZ;
-		if (secfrag >= 1000000) {
-			secfrag -= 1000000;
-			uptime->seconds1++;
-			write_barrier();
-			uptime->useconds = secfrag;
-			write_barrier();
-			uptime->seconds2 = uptime->seconds1;
-		} else
-			uptime->useconds += 1000000 / HZ;
+		uint64_t usec = (1000000 / HZ) * current_tick;
+
+		sysarg_t secs = usec / 1000000;
+		sysarg_t usecs = usec % 1000000;
+
+		uptime->seconds1 = secs;
+		write_barrier();
+		uptime->useconds = usecs;
+		write_barrier();
+		uptime->seconds2 = secs;
 	}
 }
@@ -130,9 +123,8 @@
 static void cpu_update_accounting(void)
 {
-	irq_spinlock_lock(&CPU->lock, false);
+	// FIXME: get_cycle() is unimplemented on several platforms
 	uint64_t now = get_cycle();
-	CPU->busy_cycles += now - CPU->last_cycle;
-	CPU->last_cycle = now;
-	irq_spinlock_unlock(&CPU->lock, false);
+	atomic_time_increment(&CPU->busy_cycles, now - CPU_LOCAL->last_cycle);
+	CPU_LOCAL->last_cycle = now;
 }
 
@@ -146,5 +138,10 @@
 void clock(void)
 {
-	size_t missed_clock_ticks = CPU->missed_clock_ticks;
+	size_t missed_clock_ticks = CPU_LOCAL->missed_clock_ticks;
+	CPU_LOCAL->missed_clock_ticks = 0;
+
+	CPU_LOCAL->current_clock_tick += missed_clock_ticks + 1;
+	uint64_t current_clock_tick = CPU_LOCAL->current_clock_tick;
+	clock_update_counters(current_clock_tick);
 
 	/* Account CPU usage */
@@ -156,39 +153,31 @@
 	 *
 	 */
-	size_t i;
-	for (i = 0; i <= missed_clock_ticks; i++) {
-		/* Update counters and accounting */
-		clock_update_counters();
-		cpu_update_accounting();
+
+	irq_spinlock_lock(&CPU->timeoutlock, false);
+
+	link_t *cur;
+	while ((cur = list_first(&CPU->timeout_active_list)) != NULL) {
+		timeout_t *timeout = list_get_instance(cur, timeout_t, link);
+
+		if (current_clock_tick <= timeout->deadline) {
+			break;
+		}
+
+		list_remove(cur);
+		timeout_handler_t handler = timeout->handler;
+		void *arg = timeout->arg;
+		atomic_bool *finished = &timeout->finished;
+
+		irq_spinlock_unlock(&CPU->timeoutlock, false);
+
+		handler(arg);
+
+		/* Signal that the handler is finished. */
+		atomic_store_explicit(finished, true, memory_order_release);
 
 		irq_spinlock_lock(&CPU->timeoutlock, false);
-
-		link_t *cur;
-		while ((cur = list_first(&CPU->timeout_active_list)) != NULL) {
-			timeout_t *timeout = list_get_instance(cur, timeout_t,
-			    link);
-
-			irq_spinlock_lock(&timeout->lock, false);
-			if (timeout->ticks-- != 0) {
-				irq_spinlock_unlock(&timeout->lock, false);
-				break;
-			}
-
-			list_remove(cur);
-			timeout_handler_t handler = timeout->handler;
-			void *arg = timeout->arg;
-			timeout_reinitialize(timeout);
-
-			irq_spinlock_unlock(&timeout->lock, false);
-			irq_spinlock_unlock(&CPU->timeoutlock, false);
-
-			handler(arg);
-
-			irq_spinlock_lock(&CPU->timeoutlock, false);
-		}
-
-		irq_spinlock_unlock(&CPU->timeoutlock, false);
 	}
-	CPU->missed_clock_ticks = 0;
+
+	irq_spinlock_unlock(&CPU->timeoutlock, false);
 
 	/*
@@ -198,21 +187,6 @@
 
 	if (THREAD) {
-		uint64_t ticks;
-
-		irq_spinlock_lock(&CPU->lock, false);
-		CPU->needs_relink += 1 + missed_clock_ticks;
-		irq_spinlock_unlock(&CPU->lock, false);
-
-		irq_spinlock_lock(&THREAD->lock, false);
-		if ((ticks = THREAD->ticks)) {
-			if (ticks >= 1 + missed_clock_ticks)
-				THREAD->ticks -= 1 + missed_clock_ticks;
-			else
-				THREAD->ticks = 0;
-		}
-		irq_spinlock_unlock(&THREAD->lock, false);
-
-		if (ticks == 0 && PREEMPTION_ENABLED) {
-			scheduler();
+		if (current_clock_tick >= CPU_LOCAL->preempt_deadline && PREEMPTION_ENABLED) {
+			thread_yield();
 #ifdef CONFIG_UDEBUG
 			/*
